<!DOCTYPE html>
<html>

<head>
    <title>Mise en forme de texte avec CSS</title>
    <html lang="fr">
    <meta charset="utf-8" />
    <link rel="stylesheet" type="text/css" href="../css/Textstyle.css" />
    <!--va chercher le fichier CSS-->
</head>

<body>
        <Nav>
				<h2 class="navigation flexnav">
					<p><a href="index.html">Balises HTML </a></p>
					<p><a href="TextCSS.html">Mise en forme du texte </a></p>
					<p><a href="Boxmodel.html">Mise en forme des boites </a></p>
					<p><a href="Formulaires.html">Formulaires </a></p>
					<p><a href="JavaScript.html">JavaScript </a></p>
					<p><a href="Illustrations.html">Illustrations </a></p>
				</h2>
				
			</nav>
    <h1>Mettre en forme un texte <br />avec CSS</h1>
    <!--tuto-->
    <!--Les selecteurs #id et .class permettent de cibler un élément: elles doivent commencer par une lettre, n'ont pas d'espace, ni caracteres speciaux-->
    <p>Cette page est un aide mémoire pour appliquer les différentes possibilités de mise en forme de texte. L'idéal
        est de la suivre avec le code HTML et CSS pour en comprendre la syntaxe.</p>
    <h2>La police avec font-family (ici h2 est par défaut)</h2>
    <p class="serif">Ce paragraphe est écrit en "Times New Roman" (ou Times ou serif).</p>
    <p class="sansserif">Ce paragraphe est écrit en helvetica ou arial ("font-family" : sans-serif).</p>
    <p class="monospace">Ce paragraphe est écrit en police monospace comme "Lucida Console", "Courier New", "Courier".</p>
    <p class="cursive">Ce paragraphe est écrit en police cursive comme "Florence" ou "Comic sans MS".</p>
    <p class="fantasy">Ce paragraphe est écrit en police fantasy, comme "Blippo".</p>
    <hr />
    <h2>La taille avec (font-size) </h2>
    <p> La taille s'exprime avec des mots clés, ou en pixels (px) ou en ems (em), sachant que em= pixel/16.</p>
    <p class="small">Dans le paragraphe, la taille du texte est "small".</p>
    <p class="medium">Dans ce paragraphe, la taille du texte est "medium" (ou 16 pixels ou 1 em). C'est la taille par
        défaut.</p>
    <p class="large">Dans ce paragraphe, la taille du texte est "large"</p>
    <p class="xlarge">Dans ce paragraphe, la taille du texte est encore plus large ("xlarge")</p>
    <hr />
    <h2>Le style avec (font-style = italique) et (font-weight = gras)</h2>
    <p class="italic">Ce paragraphe est en "italic" (oblique fait la même chose, mais c'est moins supporté).</p>
    <p class="leger">This is a font with a weight = 100.</p>
    <p class="light">This is a font with a "lighter" weight.</p>
    <p class="normal">This is a font with a "normal" weight (= 400) et on dirait que c'est pareil que lighter.</p>
    <p class="bold">This is a font with a "bold" weight ou 700.</p>
    <p class="bolder">This is a font with a "bolder" weight.</p>
    <hr />
    <h2>La casse (avec font-variant) et (text-transform)</h2>
    <p class="scap">La propriété "font-variant" permet de mettre un texte en petites majuscules avec la valeur
        "small-caps" (attention, toutes les polices ne s'y prêtent pas).</p>
    <p class="capitalize"> La propriété "text-transform" permet de passer des majuscules aux minuscules, par exemple
        "capitalize" met les premières lettres de chaque mot en majuscule.</p>
    <p class="uppercase"> "Uppercase" met toutes les lettres en majuscule</p>
    <p class="lowercase"> "Lowercase" met toutes les lettres en MINUSCULE</p>
    <p>"text-transform" accepte aussi les valeurs "inherit" (= la valeur calculée de la propriété pour l'élément
        parent) et "none".</p>
    <hr />
    <h2>Le soulignage (avec text-decoration) et l'encadrement (avec border)</h2>
    <p class="none">Par défaut, un texte n'est pas souligné, comme avec "text-décoration : none". Cette valeur peut
        être utile pour effacer le soulignement d'un lien.</p>
    <p class="inherit">"text-décoration : inherit" permet au texte d'avoir le même soulignement que son parent.</p>
    <p class="overline">Voici un texte souligné au dessus avec "text-décoration : overlined".</p>
    <p class="underline">Voici un texte souligné au dessous avec "text-décoration : underlined".</p>
    <p class="line-through">Voici un texte barré avec "text-decoration: line-through".</p>
    <p class="blink">Voici un texte mis en forme avec "blink" (mais souvent pas reconnu).</p>
    <p class="bordure"> Ce texte est encadré. Pour plus d'info, voir le maniement des "box"</p>
    <p class="none">This paragraph has no border.</p>
    <p class="dotted">This is a dotted border.</p>
    <p class="dashed">This is a dashed border.</p>
    <p class="double">This is a double border.</p>
    <p class="groove">This is a grooved border.</p>
    <p class="ridge">This is a ridged border.</p>
    <p class="inset">This is an inset border.</p>
    <p class="outset">This is an outset border.</p>
    <p class="hidden">This is a hidden border.</p>
    <table>
        <tr>
            <td>Pour que le cadre s'adapte au texte, créer un tableau
            </td>
        </tr>
    </table>
    <p><span class="cadre">une autre solution avec la balise "span"</span></p>
    <p><span class="arron">Voici un cadre avec des angles arrondis.</span></p>
    <div class="grcadre">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed non risus. Suspendisse lectus
        tortor, dignissim sit amet, adipiscing nec, ultricies sed, dolor. Cras elementum ultrices diam. Maecenas ligula
        massa, varius a, semper congue, euismod non, mi. Proin porttitor, orci nec nonummy molestie, enim est eleifend
        mi, non fermentum diam nisl sit amet erat.<p class="catrans">Voici un cadre avec des bords transparents. Le
            texte p est dans une div pour mieux voir l'effet.</p>
    </div>
    <hr />
    <h2>L'alignement horizontal (avec text-align) ou vertical (avec vertical-align)</h2>
    <p class="gauche">This paragraph is aligned to <strong>left.</strong></p>
    <p class="right">This paragraph is aligned to <strong>right.</strong></p>
    <p class="center">This paragraph is aligned to <strong>center.</strong></p>
    <p class="justify">This paragraph is aligned to <strong>justify</strong>. Lorem ipsum dolor sit amet, consectetur
        adipiscing elit. Sed non risus. Suspendisse lectus tortor, dignissim sit amet, adipiscing nec, ultricies sed,
        dolor. Cras elementum ultrices diam. Maecenas ligula massa, varius a, semper congue, euismod non, mi. Proin
        porttitor, orci nec nonummy molestie, enim est eleifend mi, non fermentum diam nisl sit amet erat.</p>
    <p>Vertical align. This is an <span class="baseline">inline text</span> example.</p>
    <p>This is a <span class="sub">sub line text</span> example.</p>
    <p> This is a <span class="super">super line text</span> example.</p>
    <p> This is a <span class="pixel">pixel</span> example.</p>
    <div class="main">
        <div class="paragraph">
            Vertical align property does not act the same way for all elements. For example, some additional CSS
            styling is needed for div elements.
        </div>
    </div>
    <p class="alignv1">Aligner une ligne.</p><br />

    <p class="alignv2"> <span class="alignv3">Aligner plusieurs <br /> lignes de texte</span> </p>


    <div class="alignv4">
        <div class="alignv5">
            <h3>Centrer un bloc </h3>
            <p>dans un conteneur de hauteur fixe</p>
        </div>
        <span></span>

    </div>
    <p></p>
    <div class="alignv6">
        <div class="alignv7">
            <p>Centrer verticalement des blocs </p>
        </div>
        <div class="alignv7">
            <p>dans un conteneur de hauteur fluide</p>
        </div>
    </div>

    <hr />
    <h2>Les espacements</h2>
    <p class="letter">On peut augmenter l'espace entre les lettres (ici de 4px).</p>
    <p class="neg">On peut aussi les reserrer (ici de -1.25px).</p>
    <p class="word">On peut augmenter l'espace entre les mots (ici de 30px).</p>
    <p class="nowrap">This paragraph has multiple spaces and
        a line break, but it will be ignored, as we used the nowrap value.</p>
    <p class="pre">This paragraph has multiple spaces and
        a line break, and we can see them, as we used the pre value.</p>
    <p class="preline">This paragraph has multiple spaces and
        a line break, but we see only the line break, as we used the preline value (les espaces en trop sont ignorés).</p>
    <p class="prewrap">This paragraph has multiple spaces and
        a line break, as we used the prewrap value.</p>
    <p class="ligne">"line-height" permet de choisir <br />l'écartement entre deux lignes.</p>
    <p class="wrap">"word-wrap:break" permetdecouperunmottroplongparrapportàl'espacedisponible (alors que la valeur
        "normal" la fera dépasser).</p>
    <hr />
    <h2>La couleur (avec color et background-color), l'ombrage (avec text-shadow), la visibilité (avec visibility)</h2>
    <p>Il y a 3 manières d'indiquer la couleur d'un texte (les couleurs peuvent être testées dans le logiciel "Aperçu")
        :</p>
    <ol>
        <li>avec un nom de couleur, par exemple <span class="purple1">"color: purple"</span>. Il y a 16 noms
            universellement supportés (et 160 dans les versions récentes des navigateurs).</li>
        <li>ou bien avec des valeurs hexadécimales : par exemple purple s'écrit <span class="purple2">"color: #800080"</span>.</li>
        <li>ou encore avec les valeurs rgb (red green blue) : purple s'écrira alors <span class="purple3">"color:
                rgb(128,0,128)"</span>.</li>
    </ol>
    <p class="transp">Avec CSS3, RGBa (red, green, blue, alpha) permet de gérer la transparence avec alpha qui peut
        varier de 0.0 (transparent) à 1.0 (opaque). </p>
    <p class="opacity">La propriété "opacity" gère la transparence de la même manière.</p>
    <p>L'ombrage est géré avec l'attribut <span class="shadow">"text-shadow"</span>.</p>
    <p>Testez aussi ces effets sur le titre.</p>
    <p>1 La propriété "visibility" specifie si un element est visible ou caché. Ce paragraphe est répété 3 fois, mais
        le second est caché. Si on veut masquer sa place, utiliser "display:none"</p>
    <p class="visible">2 La propriété "visibility" specifie si un element est visible ou caché. Ce paragraphe est
        répété 3 fois, mais le second est caché. Si on veut masquer sa place, utiliser "display:none"</p>
    <p> 3 La propriété "visibility" specifie si un element est visible ou caché. Ce paragraphe est répété 3 fois, mais
        le second est caché. Si on veut masquer sa place, utiliser "display:none"</p>
    <hr />
    <h2>Les fonds</h2>
    <p class="fond">La couleur d'un fond fonctionne de la même manière que la couleur, avec la propriété
        "background-color".</p>
    <p class="degrad">La couleur peut être dégradée et ceci de plusieurs manières. Ici de façon linéaire, avec
        "linear-gradient", de gauche à droite. Par défaut, il va du haut vers le bas.</p>
    <p class="degradiag">Encore un essai, avec un dégradé en diagonal, en rouge, avec un effet de transparence.
        ATTENTION, "linear-gradient" doit être décliné pour être lisible par tous les navigateurs.</p>
    <!--"radial-gradients sera traité avec les box-->
    <div class="photo">
        <p class="ltrans">Ceci est un tableau de Paul Klee en fond avec un texte opaque à 10%. Il faut mieux éviter les
            photos trop lourdes, cad supérieures à 20k (à vérifier).</p>
    </div>

    <hr />
    <h2>Le cascading</h2>
    <p class="xlarge bolder sansserif purple1 shadow fond degradiag">Paragraphe 1 pour tester le "cascading".</p>
    <p class="xlarge bolder sansserif purple1 shadow degradiag fond">Paragraphe 2 pour tester le "cascading".</p>
    <p>Les règles de priorités :</p>
    <ol>
        <li>Une déclaration de style "en ligne" (dans le code HTML avec l'attribut style) <span class="ex">&lt;p style
                ="color:red;"&gt;</span> dans body.</li>
        <li>le selecteur d'identifiant id <span class="ex">#</span> dans la balise style dans body</li>
        <li>le selecteur d'identifiant id <span class="ex">#</span> (code dans .css)</li>
        <li>class, pseudo class, selecteur d'attributs (code dans .css)</li>
        <li>nom de balise <span class="ex">&lt;style&gt; p {color:red;}&lt;/style&gt;</span> dans body.</li>
    </ol>
    <p>En cas d'égalité en terme de priorité </p>
    <ol>
        <li>nombre de selecteurs de même type.</li>
        <li>ordre dans le fichier CSS : le dernier est prioritaire.</li>
    </ol>
    <hr />
    <h2>Les pseudo-classes</h2>
    <div id="parent1"> Espace pour tester les pseudo-classes
        <p>1§ Elles permettent de changer le style d'un élément selon son état (//dynamique)</p>
        <p>2§ Elles commencent toujours par le symbole ":"</p>
        <p>3§ Elles sont souvent utilisées sur les liens, par exemple (si plusieurs, mettre dans cet ordre):</p>
        <ol>
            <li>":link" pour styliser un lien non visité</li>
            <li>":visited" pour styliser un lien visité (mais les navigateurs l'ignore souvent)</li>
            <li>":hover" changer l'aspect quand le curseur passe dessus</li>
            <li>":active" modifier l'aspect du lien lors du clic</li>
        </ol>
        <p>4§ ":first-child" (ou ":last-child") permet de sélectionner le premier (ou le dernier) d'un certain type
            d'élément par rapport à l'élément parent.</p>
        <p>5§ ":nth-child" permet de cibler certains éléments enfant par rapport à l'élément parent avec un nombre ou
            un mot clé.</p>
    </div>
    <hr />
    <h2>Les pseudo-éléments</h2>
    <div id="parent2"> Espace pour tester les pseudo-elements
        <p>Ils permettent de modifier l'apparence d'une partie d'un élément ou d'ajouter du contenu au début ou à la
            fin de l'élément</p>
        <p>Ils commencent toujours par le symbole "::"</p>
        <p>Il existe seulement 5 pseudo-éléments:</p>
        <ul>
            <li>"::first-letter" modifie l'apparence de la première lettre du texte d'un élément. ATTENTION, il ne
                supporte que les propriétés liées à la police, la taille, la couleur, le fond, le bord, margin et
                padding, text-decoration, text-transform, vertical-align, line-height, float et clear.</li>
            <li>"::first-line" modifie l'apparence de la première ligne du texte d'un élément. ATTENTION, il ne
                supporte toutes les propriétés, mais il supporte celles liées à la couleur, à la taille, au fond, au
                bord (border), lettre-spacing, word-spacing, text-decoration, text-transform, vertical-align,
                line-height et clear.</li>
            <li>"::selection" pour cibler et mettre en forme la partie sélectionnée d'un élément par double clic, avec
                les propriétés color, background, cursor, outline</li>
            <li>"::before" insère un contenu (texte, image...) au début d'un élément HTML</li>
            <li>"::after" insère un contenu (texte, image...) à la fin d'un élément HTML</li>
        </ul>
    </div>

    <hr />
    <h1>Autres mises en forme directement avec HTML</h1>
    <h2 class="black">Ici un titre avec la balise h2</h2>
    <h3>Ici un titre avec la balise h3</h3>
    <h4>Ici un titre avec la balise h4</h4>
    <h5>Ici un titre avec la balise h5</h5>
    <h6>Ici un titre avec la balise h6</h6>
    <p>Ici un titre avec la balise p </p>
    <hr /> <!-- commentaire html : ca trace une ligne-->
    <p>Texte sans mise en forme particulière</p>
    <p><b>Texte en gras avec la balise "b" </b></p>
    <p><strong> Texte important avec la balise "strong"</strong>: ca ressemble à "b"</p>
    <p><i> Texte en italique avec la balise "i"</i></p>
    <p><em> Texte important avec la balise "em" </em>: ça ressemble à "i"</p>
    <p><small> Texte plus petit avec la balise "small" </small></p>
    <p><big> Texte plus gros avec la balise "big"</big></p>
    <p>this is <sub> subscripted text with "sub" tag</sub></p>
    <p>this is <sup> superscripted text with "sup" tag</sup></p>
    <p><ins> inserted text with "ins" tag</ins></p>
    <p><del> deleted text with "del" tag</del></p>
    <p>Ici un texte <mark>surligné avec "mark"</mark></p>
    <hr width="150px" /><!-- la longueur de la ligne peut être définie, centrée par défaut-->
    <p>This is regular text<br /> with a break line</p>
</body>

</html>